CVC4::DatatypeConstructorArg Class Reference

A Datatype constructor argument (i.e., a Datatype field). More...

`#include <datatype.h>`

## Public Member Functions

std::string | getName () const throw ()
| Get the name of this constructor argument.
Expr | getSelector () const
| Get the selector for this constructor argument; this call is only permitted after resolution.
Expr | getConstructor () const
| Get the associated constructor for this constructor argument; this call is only permitted after resolution.
SelectorType | getType () const
| Get the type of the selector for this constructor argument; this call is only permitted after resolution.
std::string | getTypeName () const
| Get the name of the type of this constructor argument (Datatype field).
bool | isResolved () const throw ()
| Returns true iff this constructor argument has been resolved.

## Friends

class | DatatypeConstructor
class | Datatype

## Detailed Description

A Datatype constructor argument (i.e., a Datatype field).

Definition at line 119 of file datatype.h.

## Member Function Documentation

## getConstructor()

Expr CVC4::DatatypeConstructorArg::getConstructor | ( |  | ) | const

Get the associated constructor for this constructor argument; this call is only permitted after resolution.

## getName()

std::string CVC4::DatatypeConstructorArg::getName | ( |  | ) | const
throw | ( | ) |  |  |

Get the name of this constructor argument.

## getSelector()

Expr CVC4::DatatypeConstructorArg::getSelector | ( |  | ) | const

Get the selector for this constructor argument; this call is only permitted after resolution.

## getType()

SelectorType CVC4::DatatypeConstructorArg::getType | ( |  | ) | const

Get the type of the selector for this constructor argument; this call is only permitted after resolution.

## getTypeName()

std::string CVC4::DatatypeConstructorArg::getTypeName | ( |  | ) | const

Get the name of the type of this constructor argument (Datatype field).

Can be used for not-yet-resolved Datatypes (in which case the name of the unresolved type, or "[self]" for a self-referential type is returned).

## isResolved()

bool CVC4::DatatypeConstructorArg::isResolved | ( |  | ) | const
throw | ( | ) |  |  |

inline

Returns true iff this constructor argument has been resolved.

Definition at line 755 of file datatype.h.

## Friends And Related Symbol Documentation

## Datatype

friend class Datatype

friend

Definition at line 129 of file datatype.h.

## DatatypeConstructor

friend class DatatypeConstructor

friend

Definition at line 128 of file datatype.h.

The documentation for this class was generated from the following file:

- src/util/datatype.h